Index: /bdm/math/libDC.h
===================================================================
--- /bdm/math/libDC.h (revision 14)
+++ /bdm/math/libDC.h (revision 19)
@@ -114,4 +114,6 @@
 	//! Construct by decomposition of full matrix V.
 	ldmat( mat V );
+	//! Construct diagonal matrix with diagonal D0
+	ldmat( vec D0 );
 	ldmat ();
 
@@ -170,6 +172,6 @@
 inline ldmat& ldmat::operator += (const ldmat &ldA)  {this->add(ldA);return *this;}
 inline ldmat& ldmat::operator -= (const ldmat &ldA)  {this->add(ldA,-1.0);return *this;}
-inline int ldmat::cols(){return L.cols();}
-inline int ldmat::rows(){return L.rows();}
+inline int ldmat::cols(){return dim;}
+inline int ldmat::rows(){return dim;}
 
 #endif // DC_H
Index: /bdm/math/libDC.cpp
===================================================================
--- /bdm/math/libDC.cpp (revision 18)
+++ /bdm/math/libDC.cpp (revision 19)
@@ -22,7 +22,11 @@
 
 ldmat::ldmat() {
-	vec D ;
-	mat L;
 	dim = 0;
+}
+
+ldmat::ldmat(const vec D0) {
+	D = D0;
+	dim = D0.length();
+	L = eye(dim);
 }
 
@@ -65,4 +69,5 @@
 	os << "L:" << ld.L << endl;
 	os << "D:" << ld.D << endl;
+	return os;
 }
 
@@ -165,4 +170,5 @@
 // sum logarithms of diagobal elements
 	for ( i=0; i<D.length(); i++ ){ldet+=log( D( i ) );};
+	return ldet;
 }
 
@@ -182,4 +188,5 @@
 	int i;
 	for ( i=0;i<D.length();i++ ){D( i )*=x;};
+	return *this;
 }
 
@@ -187,5 +194,5 @@
 	int i,j;
 	vec res( dim );
-	double sum;
+	//double sum;
 	for ( i=0;i<dim;i++ ) {//for each element of result
 		res( i ) = 0.0;
@@ -194,6 +201,6 @@
 		}
 	}
-	vec res2 = L.transpose()*diag( sqrt( D ) )*x;
-	return res2;
+//	vec res2 = L.transpose()*diag( sqrt( D ) )*x;
+	return res;
 }
 
Index: /bdm/stat/libFN.h
===================================================================
--- /bdm/stat/libFN.h (revision 15)
+++ /bdm/stat/libFN.h (revision 19)
@@ -2,5 +2,5 @@
 // C++ Interface: itpp_ext
 //
-// Description: 
+// Description:
 //
 //
@@ -14,14 +14,60 @@
 
 using namespace itpp;
- 
-class constfn : public fnc {
-	RV rv;
-	ivec indexlist; // needed by evalsome
-	vec val;
 
-public:
-	vec eval() {return val;};
-	vec eval(vec &cond) {return val;};
-	
-	vec evalsome(ivec &rvind);
-}
+//! class representing function $f(x) = a$, here rv is empty
+class constfn : public fnc
+{
+		RV rv;
+		vec val;
+
+	public:
+		vec eval() {return val;};
+		vec eval ( vec &cond ) {return val;};
+		//!Default constructor
+		constfn ( const vec &val0 ) :rv(),val ( val0 ) {};
+};
+
+//! Class representing function $f(x) = Ax+B$
+class linfn: public fnc
+{
+		RV rv;
+		ivec indexlist; // needed by evalsome
+		mat A;
+		vec B;
+	public :
+		vec eval ( vec &cond ) {it_assert_debug ( cond.length() ==rv.count(), "linfn::eval Wrong cond." );return A*cond+B;};
+
+		linfn evalsome ( ivec &rvind );
+		linfn ( const RV &rv0 ) :rv ( rv0 ),A ( eye ( rv0.count() ) ),B ( zeros ( rv0.count() ) ) { indexlist=rv.indexlist();};
+		linfn ( const RV &rv0, const mat &A0 ) : rv ( rv0 ), A ( A0 ), B ( zeros ( rv0.count() ) ) { indexlist=rv.indexlist();};
+		linfn ( const RV &rv0, const mat &A0, const vec &B0 ) :rv ( rv0 ), A ( A0 ), B ( B0 ) { indexlist=rv.indexlist();};
+};
+
+//! Class representing function $f(x,u) = Ax+Bu$
+class bilinfn: public fnc
+{
+		RV rv;
+		ivec indexlist; // needed by evalsome
+		mat A;
+		mat B;
+	public :
+		vec eval ( vec &cond )
+		{
+			it_assert_debug ( cond.length() ==rv.count(), "linfn::eval Wrong cond." );
+			int sizex = A.cols();
+			return A*cond(0,sizex-1)+B*cond(sizex,-1);//-1 = end (in matlab)
+		};
+		vec eval ( vec &xcond, vec &ucond )
+		{
+			it_assert_debug ( xcond.length() ==rv.count(), "linfn::eval Wrong cond." );
+			return A*xcond+B*ucond;
+		};
+
+		bilinfn evalsome ( ivec &rvind );
+		bilinfn ( const RV &x0, const RV &u0 ) :A ( eye ( x0.count() ) ),B ( zeros ( x0.count(),u0.count() ) )
+		{
+			rv=x0; rv.add ( u0 );
+			indexlist=rv.indexlist();
+		};
+		bilinfn ( const RV &x0, const RV &u0, const mat &A0, const mat &B0 );
+};
Index: /bdm/stat/libDS.h
===================================================================
--- /bdm/stat/libDS.h (revision 18)
+++ /bdm/stat/libDS.h (revision 19)
@@ -15,5 +15,5 @@
 
 #include <itpp/itbase.h>
-//#include <std>
+#include "libBM.h"
 
 using namespace itpp;
@@ -38,5 +38,7 @@
 	void write(vec &ut){it_error("MemDS::write is not supported");}
 	void write(vec &ut,ivec &indexes){it_error("MemDS::write is not supported");}
-}
+	void step();
+	MemDS(mat &Dat, ivec &rowid, ivec &delays);
+};
 
 
Index: /bdm/stat/libBM.cpp
===================================================================
--- /bdm/stat/libBM.cpp (revision 15)
+++ /bdm/stat/libBM.cpp (revision 19)
@@ -68,2 +68,10 @@
 }
 
+ivec RV::indexlist(){
+	ivec indlist(size);
+	int i;
+	int pos = 0;
+	for(i=0;i<len;i++){
+		indlist.set_subvector(pos,pos+sizes(i)-1, ids(i));
+	}
+}
Index: /bdm/stat/libBM.h
===================================================================
--- /bdm/stat/libBM.h (revision 18)
+++ /bdm/stat/libBM.h (revision 19)
@@ -25,5 +25,8 @@
 */
 class RV {
-	int size,len;
+	//! size = sum of sizes
+	int size;
+	//! len = number of individual rvs
+	int len;
 	ivec ids;
 	ivec sizes;
@@ -46,5 +49,5 @@
 
 	//! Return length (number of scalars) of the RV.
-	int count() {return size;}
+	int count() const {return size;} ;
 	//TODO why not inline and later??
 	
@@ -61,4 +64,6 @@
 	//! Generate new \c RV with \c time shifted by delta.
 	void t(int delta);
+	//! generate a list of indeces, i.e. which 
+	ivec indexlist();
 };
 
@@ -66,7 +71,10 @@
 
 
-//! Class representing function of variables
+//! Class representing function $f(x)$ of variable $x$ represented by \c rv
 class fnc {
 	RV rv;
+public: 
+	//! function evaluates numerical value of $f(x)$ at $x=cond$
+	virtual vec eval(vec &cond){}; //Fixme: virtual?
 };
 
@@ -93,5 +101,5 @@
 //	virtual vec moment ( const int order = 1 );
 	//! Returns a sample from the density, $x \sim epdf(rv)$
-	virtual vec sample (){};
+	virtual vec sample ()=0;
 	virtual double eval(const vec &val){};
 };
@@ -119,4 +127,5 @@
 */
 class DS {
+protected:
 	//!Observed variables, returned by \c getdata().
 	RV Drv; 
Index: /bdm/stat/libFN.cpp
===================================================================
--- /bdm/stat/libFN.cpp (revision 14)
+++ /bdm/stat/libFN.cpp (revision 19)
@@ -2,13 +2,20 @@
 #include "libFN.h"
 
-using namespace itpp;
-
 using std::endl;
 
-constfn::constfn(RV rv){
-
+linfn linfn::evalsome ( ivec &rvind )
+{
+	return *this;
 }
 
-vec constfn::evalsome(ivec rvind){
-	
-}
+bilinfn::bilinfn ( const RV &x0, const RV &u0, const mat &A0, const mat &B0 )
+{
+	it_assert_debug ( A0.cols() ==A0.rows() ==x0.count(), "linfn:: wrong A" );
+	it_assert_debug ( ( B0.rows() ==x0.count() ) & ( B0.cols() ==u0.count() ), "linfn:: wrong B" );
+
+	A = A0;
+	B = B0;
+	rv=x0; rv.add ( u0 );
+	indexlist=rv.indexlist();
+};
+
Index: /bdm/stat/libDS.cpp
===================================================================
--- /bdm/stat/libDS.cpp (revision 18)
+++ /bdm/stat/libDS.cpp (revision 19)
@@ -2,7 +2,9 @@
 #include "libDS.h"
 
-using namespace itpp;
+//using namespace itpp;
 
 void MemDS::getdata(vec &dt){
+	int i;
+	
 	it_assert_debug(dt.length()==rowid.length(), "MemDS:getdata incompatible dt");
 	for(i=0;i<rowid.length();i++){
@@ -12,5 +14,5 @@
 
 void MemDS::getdata(vec &dt,ivec &indeces){
-	int j;
+	int j,i;
 	it_assert_debug(dt.length()==indeces.length(), "MemDS:getdata incompatible dt");
 	for(i=0;i<indeces.length();i++){
@@ -32,9 +34,9 @@
 }
 
-MemDS::MemDS(vec &Dat, ivec &rowid, ivec &delays){
-	it_assert_debug(max(rowid)<=Dat.rows,"MemDS rowid is too high for given Dat.")
-	it_assert_debug(max(delays)<Dat.cols,"MemDS delays are too high.")
+MemDS::MemDS(mat &Dat, ivec &rowid, ivec &delays){
+	it_assert_debug(max(rowid)<=Dat.rows(),"MemDS rowid is too high for given Dat.");
+	it_assert_debug(max(delays)<Dat.cols(),"MemDS delays are too high.");
 	
-	time = max(delayes); 
+	time = max(delays); 
 	Data = Dat;
 }
Index: /bdm/CMakeLists.txt
===================================================================
--- /bdm/CMakeLists.txt (revision 19)
+++ /bdm/CMakeLists.txt (revision 19)
@@ -0,0 +1,9 @@
+# Create a library called "Hello" which includes the source file "hello.cxx".
+# The extension is already found.  Any number of sources could be listed here
+
+add_library (bdm itpp_ext.cpp math/libDC.cpp stat/libBM stat/libEF stat/libDS  stat/libFN estim/libKF estim/libPF)
+
+add_subdirectory (stat)
+add_subdirectory (math)
+add_subdirectory (estim)
+
Index: /tests/testKF.cpp
===================================================================
--- /tests/testKF.cpp (revision 18)
+++ /tests/testKF.cpp (revision 19)
@@ -9,4 +9,5 @@
 
 int main() {
+
 
 	// Klaman filter
@@ -41,5 +42,5 @@
 	Xt2=zeros( 2,Ndat );
 
-	Kalman<ldmat> KF( A,B,C,D,ldmat(R),ldmat(Q),ldmat(P0),mu0 );
+	Kalman<ldmat> KF( A,B,C,D,ldmat(diag(R)),ldmat(diag(Q)),ldmat(diag(P0)),mu0 );
 //	cout << KF;
 	KalmanFull KF2( A,B,C,D,R,Q,P0,mu0 );
Index: /tests/testPF.cpp
===================================================================
--- /tests/testPF.cpp (revision 14)
+++ /tests/testPF.cpp (revision 19)
@@ -1,6 +1,6 @@
 #include <itpp/itbase.h>
-#include "libPF.h"
-#include "libDC.h"
-#include "libEF.h"
+#include <estim/libPF.h>
+#include <math/libDC.h>
+#include <stat/libEF.h>
 
 using namespace itpp;
@@ -17,5 +17,6 @@
 	
 	mat A = "1";
-	ldmat R("1");
+	vec vR = "1";
+	ldmat R(vR);
 	
 	
Index: /tests/CMakeLists.txt
===================================================================
--- /tests/CMakeLists.txt (revision 19)
+++ /tests/CMakeLists.txt (revision 19)
@@ -0,0 +1,16 @@
+# Make sure the compiler can find include files from our Hello library.
+include_directories (${BDM_SOURCE_DIR}/bdm)
+
+# Make sure the linker can find the Hello library once it is built.
+link_directories (${BDM_BINARY_DIR}/bdm)
+
+# Add executable called "helloDemo" that is built from the source files
+# "demo.cxx" and "demo_b.cxx".  The extensions are automatically found.
+add_executable (test0 test0.cpp)
+add_executable (testKF testKF.cpp)
+add_executable (testPF testPF.cpp)
+
+# Link the executable to the Hello library.
+target_link_libraries (test0 bdm itpp)
+target_link_libraries (testKF bdm itpp)
+target_link_libraries (testPF bdm itpp)
Index: /Doxyfile
===================================================================
--- /Doxyfile (revision 3)
+++ /Doxyfile (revision 19)
@@ -256,10 +256,10 @@
 CLASS_DIAGRAMS         = YES
 HIDE_UNDOC_RELATIONS   = YES
-HAVE_DOT               = NO
+HAVE_DOT               = YES
 CLASS_GRAPH            = YES
 COLLABORATION_GRAPH    = YES
 GROUP_GRAPHS           = YES
 UML_LOOK               = NO
-TEMPLATE_RELATIONS     = NO
+TEMPLATE_RELATIONS     = YES
 INCLUDE_GRAPH          = YES
 INCLUDED_BY_GRAPH      = YES
Index: /BDM.kdevelop.filelist
===================================================================
--- /BDM.kdevelop.filelist (revision 19)
+++ /BDM.kdevelop.filelist (revision 19)
@@ -0,0 +1,22 @@
+CMakeLists.txt
+bdm/CMakeLists.txt
+bdm/estim/libKF.cpp
+bdm/estim/libKF.h
+bdm/estim/libPF.cpp
+bdm/estim/libPF.h
+bdm/itpp_ext.cpp
+bdm/itpp_ext.h
+bdm/math/libDC.cpp
+bdm/math/libDC.h
+bdm/stat/libBM.cpp
+bdm/stat/libBM.h
+bdm/stat/libDS.cpp
+bdm/stat/libDS.h
+bdm/stat/libEF.cpp
+bdm/stat/libEF.h
+bdm/stat/libFN.cpp
+bdm/stat/libFN.h
+tests/CMakeLists.txt
+tests/test0.cpp
+tests/testKF.cpp
+tests/testPF.cpp
Index: /BDM.kdevelop
===================================================================
--- /BDM.kdevelop (revision 19)
+++ /BDM.kdevelop (revision 19)
@@ -0,0 +1,198 @@
+<?xml version = '1.0'?>
+<kdevelop>
+  <general>
+  <projectmanagement>KDevCustomProject</projectmanagement>
+  <projectdirectory>/home/smidl/work/mixpp</projectdirectory>
+  <absoluteprojectpath>true</absoluteprojectpath>
+    <author></author>
+    <email></email>
+    <version>$VERSION$</version>
+    <primarylanguage>C++</primarylanguage>
+    <ignoreparts/>
+    <secondaryLanguages>
+      <language>C</language>
+    </secondaryLanguages>
+    <projectname>BDM</projectname>
+    <description></description>
+    <defaultencoding></defaultencoding>
+  </general>
+  <kdevcustomproject>
+    <filelistdirectory>/home/smidl/work/mixpp</filelistdirectory>
+    <run>
+      <mainprogram>/home/smidl/work/mixpp/tests/testPF</mainprogram>
+      <directoryradio>custom</directoryradio>
+      <customdirectory>/home/smidl/work/mixpp</customdirectory>
+      <programargs></programargs>
+      <terminal>false</terminal>
+      <autocompile>true</autocompile>
+      <envvars/>
+      <globaldebugarguments></globaldebugarguments>
+      <globalcwd>/home/smidl/work/mixpp</globalcwd>
+      <useglobalprogram>false</useglobalprogram>
+      <autoinstall>false</autoinstall>
+      <autokdesu>false</autokdesu>
+    </run>
+    <build>
+      <buildtool>make</buildtool>
+      <builddir>/home/smidl/work/mixpp</builddir>
+    </build>
+    <make>
+      <abortonerror>false</abortonerror>
+      <numberofjobs>1</numberofjobs>
+      <dontact>false</dontact>
+      <makebin></makebin>
+      <selectedenvironment>default</selectedenvironment>
+      <environments>
+        <default/>
+      </environments>
+      <prio>0</prio>
+      <defaulttarget></defaulttarget>
+      <makeoptions></makeoptions>
+    </make>
+    <filetypes>
+      <filetype>*.java</filetype>
+      <filetype>*.h</filetype>
+      <filetype>*.H</filetype>
+      <filetype>*.hh</filetype>
+      <filetype>*.hxx</filetype>
+      <filetype>*.hpp</filetype>
+      <filetype>*.c</filetype>
+      <filetype>*.C</filetype>
+      <filetype>*.cc</filetype>
+      <filetype>*.cpp</filetype>
+      <filetype>*.c++</filetype>
+      <filetype>*.cxx</filetype>
+      <filetype>Makefile</filetype>
+      <filetype>CMakeLists.txt</filetype>
+    </filetypes>
+    <blacklist/>
+    <other>
+      <prio>0</prio>
+      <otherbin></otherbin>
+      <defaulttarget></defaulttarget>
+      <otheroptions></otheroptions>
+      <selectedenvironment>default</selectedenvironment>
+      <environments>
+        <default/>
+      </environments>
+    </other>
+  </kdevcustomproject>
+  <kdevfilecreate>
+    <filetypes/>
+    <useglobaltypes>
+      <type ext="ui" />
+      <type ext="cpp" />
+      <type ext="h" />
+    </useglobaltypes>
+  </kdevfilecreate>
+  <kdevdoctreeview>
+    <projectdoc>
+      <userdocDir>html/</userdocDir>
+      <apidocDir>html/</apidocDir>
+    </projectdoc>
+    <ignoreqt_xml/>
+    <ignoredoxygen/>
+    <ignorekdocs/>
+    <ignoretocs/>
+    <ignoredevhelp/>
+  </kdevdoctreeview>
+  <cppsupportpart>
+    <filetemplates>
+      <interfacesuffix>.h</interfacesuffix>
+      <implementationsuffix>.cpp</implementationsuffix>
+    </filetemplates>
+  </cppsupportpart>
+  <kdevcppsupport>
+    <codecompletion>
+      <includeGlobalFunctions>true</includeGlobalFunctions>
+      <includeTypes>true</includeTypes>
+      <includeEnums>true</includeEnums>
+      <includeTypedefs>false</includeTypedefs>
+      <automaticCodeCompletion>true</automaticCodeCompletion>
+      <automaticArgumentsHint>true</automaticArgumentsHint>
+      <automaticHeaderCompletion>true</automaticHeaderCompletion>
+      <codeCompletionDelay>250</codeCompletionDelay>
+      <argumentsHintDelay>400</argumentsHintDelay>
+      <headerCompletionDelay>250</headerCompletionDelay>
+      <showOnlyAccessibleItems>false</showOnlyAccessibleItems>
+      <completionBoxItemOrder>0</completionBoxItemOrder>
+      <howEvaluationContextMenu>true</howEvaluationContextMenu>
+      <showCommentWithArgumentHint>true</showCommentWithArgumentHint>
+      <statusBarTypeEvaluation>false</statusBarTypeEvaluation>
+      <namespaceAliases>std=_GLIBCXX_STD;__gnu_cxx=std</namespaceAliases>
+      <processPrimaryTypes>true</processPrimaryTypes>
+      <processFunctionArguments>false</processFunctionArguments>
+      <preProcessAllHeaders>false</preProcessAllHeaders>
+      <parseMissingHeadersExperimental>false</parseMissingHeadersExperimental>
+      <resolveIncludePathsUsingMakeExperimental>false</resolveIncludePathsUsingMakeExperimental>
+      <alwaysParseInBackground>true</alwaysParseInBackground>
+      <usePermanentCaching>true</usePermanentCaching>
+      <alwaysIncludeNamespaces>false</alwaysIncludeNamespaces>
+      <includePaths>.;</includePaths>
+    </codecompletion>
+    <references/>
+    <qt>
+      <used>false</used>
+      <version>3</version>
+      <includestyle>3</includestyle>
+      <root>/usr/share/qt3</root>
+      <designerintegration>EmbeddedKDevDesigner</designerintegration>
+      <qmake>/usr/bin/qmake-qt3</qmake>
+      <designer></designer>
+      <designerpluginpaths/>
+    </qt>
+    <creategettersetter>
+      <prefixGet></prefixGet>
+      <prefixSet>set</prefixSet>
+      <prefixVariable>m_,_</prefixVariable>
+      <parameterName>theValue</parameterName>
+      <inlineGet>true</inlineGet>
+      <inlineSet>true</inlineSet>
+    </creategettersetter>
+    <splitheadersource>
+      <enabled>false</enabled>
+      <synchronize>true</synchronize>
+      <orientation>Vertical</orientation>
+    </splitheadersource>
+  </kdevcppsupport>
+  <kdevfileview>
+    <groups>
+      <group pattern="CMakeLists.txt;*.cmake;" name="CMake" />
+      <group pattern="*.h;*.hxx" name="Header" />
+      <group pattern="*.cpp;*.c;*.C;*.cxx" name="Sources" />
+      <group pattern="*.ui" name="Qt Designer files" />
+      <hidenonprojectfiles>true</hidenonprojectfiles>
+      <hidenonlocation>false</hidenonlocation>
+    </groups>
+    <tree>
+      <hidepatterns>*.o,*.lo,CVS,*~,cmake*</hidepatterns>
+      <hidenonprojectfiles>false</hidenonprojectfiles>
+    </tree>
+  </kdevfileview>
+  <kdevdebugger>
+    <general>
+  <projectmanagement>KDevCustomProject</projectmanagement>
+  <projectdirectory>/home/smidl/work/mixpp</projectdirectory>
+  <absoluteprojectpath>true</absoluteprojectpath>
+      <gdbpath></gdbpath>
+      <dbgshell></dbgshell>
+      <configGdbScript></configGdbScript>
+      <runShellScript></runShellScript>
+      <runGdbScript></runGdbScript>
+      <breakonloadinglibs>true</breakonloadinglibs>
+      <separatetty>false</separatetty>
+      <floatingtoolbar>false</floatingtoolbar>
+      <raiseGDBOnStart>false</raiseGDBOnStart>
+    </general>
+    <display>
+      <staticmembers>false</staticmembers>
+      <demanglenames>true</demanglenames>
+      <outputradix>10</outputradix>
+    </display>
+  </kdevdebugger>
+  <ctagspart>
+    <customArguments/>
+    <customTagfilePath>/home/smidl/work/mixpp/tags</customTagfilePath>
+    <activeTagsFiles/>
+  </ctagspart>
+</kdevelop>
Index: /CMakeLists.txt
===================================================================
--- /CMakeLists.txt (revision 19)
+++ /CMakeLists.txt (revision 19)
@@ -0,0 +1,13 @@
+# The name of our project is "BDM".  CMakeLists files in this project can
+# refer to the root source directory of the project as ${BDM_SOURCE_DIR} and
+# to the root binary directory of the project as ${BDM_BINARY_DIR}.
+project (BDM)
+
+#This is for UNIX makefile which does only one release at a time.
+SET(CMAKE_BUILD_TYPE Debug)
+
+# Recurse into the "dbm" and "tests" subdirectories.  This does not actually
+# cause another cmake executable to run.  The same process will walk through
+# the project's entire directory structure.
+add_subdirectory (bdm)
+add_subdirectory (tests)
